'************
'PADS VB Script  combined_refdes15 v1.5 16-12-03  Author: Ron Olinyk   rono@mindlinktech.com
'Copyright (c)2003 Mindlink Technologies All rights reserved.   www.mindlinktech.com
'This program is provided as is without guarantees of any kind.
'Works with: PADS PowerPCB 3.x+, PADS PowerLogic 3.x+
'Will generate a BOM from PPCB or PowerLogic for current design combining all Ref Des 
'  for Parttype on a line(s). Report is sorted on PartType.
'Fields used: Item Qty RefDes PartType Value PCB_Decal
'Enter the maximum character column width for the Ref Des field, OK -valid
'  entry range is 4 to 100.
'Report is dumped to Notepad (which must be in system path).
'Current design file path and name is pushed to clipboard -to fast save
'  report in Notepad press Ctrl-V to paste entry into SaveAs dialog
'v1.2 -updated to include PCB Decals
'v1.3 -updated to also work with PowerLogic
'v1.4 -removed buggy Notepad sendkeys routine to change font 
'v1.5 -modified report to display Parttypes by unique Value i.e. if a Parttype has
'      2 components with different value attributes they are printed as 2 separate lines
'     -made PCB Decal column option selectable by user       
'***************************************************************************************

Option Explicit
Private Const Colms = Array("Item", "Qty", "Ref Des", "Part Type", "Value", "PCB Decal")
Private Const C_Wd  = Array(     4,     4,        12,          16,         12,       20)
Private Const C_Aln  = Array(     1,     1,         0,           0,          0,        0)
Private rfds As Integer
Private pt%, vlu%, pcbdl%, fname$, tempFile As String, RptLen%, i%
Private more_rd As Boolean, part As Object, cmpstr$, appnam$
Private pads_nam As String
Private ary_cmps() As String

Sub Main

  appnam = "Notepad"
  pads_nam = UCase(Name)
  
	Begin Dialog UserDialog 290,133,"Combined Ref Des Report",.ML_Lister ' %GRID:10,7,1,1
		GroupBox 10,7,270,56,"",.GroupBox1
		Text 20,35,180,14,"Max Ref Des column width:",.Text1
		TextBox 200,28,60,21,.RefDesLen
		OKButton 40,105,90,21,.OK
		CancelButton 160,105,90,21,.Cancel
		CheckBox 60,77,20,14,"CheckBox1",.cbxPCBDcl
		Text 90,77,160,14,"Include PCB Decals",.Text2
	End Dialog
	Dim dlg As UserDialog
	Dialog dlg

End Sub

Private Sub CRD_Bom(PCBdcl As Integer)
Dim xcnt As Long
Dim xub As Long
Dim pbar As Integer
Dim pt_cnt As Double

	fname = ActiveDocument
	pt = 16
	pcbdl = 20
	vlu = 12
	Dim itm%, newlincnt%, newRDStr$, App, pdcl%, alt_pdcl$, altdcl_found As Boolean
    altdcl_found = False
	If fname = "" Then
		fname = "Untitled"
	End If
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile For Output As #1
	Print #1, "Part Report for "; fname; " on "; Now
	Print #1

	StatusBarText = "Generating report..."
	RptLen = UBound(Colms)
	If PCBdcl = 0 Then RptLen = RptLen - 1
	CurCol = 0
	For i = 0 To RptLen 
		PrntData Colms(i)
		RptLen = RptLen + C_Wd(i)
	Next
	Print #1
	Print #1, String(RptLen + 6, "-")
	
	pt_cnt = 100 / ActiveDocument.PartTypes.Count
	
  For Each part In ActiveDocument.PartTypes
    
    UpdPB(pt_cnt)
    CompAry(part)    
	xub = UBound(ary_cmps, 2)
	For xcnt = 1 To xub
	  more_rd = True
	  newlincnt = 1
      cmpstr = ary_cmps(2, xcnt)
      cmpstr = Left(cmpstr, Len(cmpstr)-1)
      
      itm = itm + 1
	  Do While more_rd = True
	   If Len(cmpstr) > rfds Then
	      newRDStr = MaxLen(cmpstr)
	      cmpstr = Right(cmpstr,Len(cmpstr)-Len(newRDStr))
	   Else
	      newRDStr = cmpstr
	   End If
	   
	   If newlincnt = 1 Then
	  	  CurCol = 0
	  	  PrntData CStr(itm)
	  	  PrntData ary_cmps(3, xcnt)          
	      PrntData newRDStr
		  PrntData part
		  PrntData ary_cmps(1, xcnt)   
		  If PCBdcl = 1 Then
		    If pads_nam = "POWERLOGIC" Then
		      PrntData part.Components(1).PCBDecal
		    Else   
		      alt_pdcl = part.Components(1).Decal
		      If part.Components.Count > 1 Then
		        For pdcl = 1 To part.Components.Count
		          If part.Components(1).Decal <> part.Components(pdcl).Decal Then
		            alt_pdcl = "*" & part.Components(1).Decal
		            altdcl_found = True
		          End If
		        Next pdcl
		      End If  
		      PrntData alt_pdcl
		    End If
		  End If 
		  Print #1
	   End If  
		   
	   If newlincnt > 1 Then
		  CurCol = 2
		  Print #1, Space(C_Wd(0) + C_Wd(1) + 2);
		  PrntData newRDStr
		  Print #1
       End If
		
		If Right(newRDStr,1) <> "," Then
		   cmpstr = ""
		   more_rd = False
		End If
		newlincnt = newlincnt + 1
	  Loop	
	Next xcnt  
  Next part
	
	
	Print #1, String(RptLen + 6, "-")
	Print #1
	If altdcl_found Then Print #1, "* More than one PCB Decal (alternates) assigned."

	StatusBarText = ""
	ProgressBar = -1
	Close #1
    MsgBox "Report saved as temp file." & vbCr & _
           "Select SAVEAS in " & appnam & vbCr & _
           "and press Ctrl-V to paste current design" & vbCr & _
           "file path and name into SaveAs dialog.", vbInformation, "Report Saving"
	On Error GoTo AppErr
	App = Shell (appnam & " " & tempfile, 1)
	On Error Resume Next
	AppActivate App
    If fname <> "" Then
      Clipboard ActiveDocument.path & "\" & Left(fname,InStr(fname,".")-1) & ".rep"
    End If
    'Kill tempFile
    Exit Sub
  AppErr:
    MsgBox "Error loading or finding editor: " & appnam & vbCr _
    & "Exiting...", vbCritical,"Design error!"
    Exit Sub
End Sub

Private Function AttrVal (obj As Object, nm As String)
	AttrVal = IIf(obj.Attributes(nm) Is Nothing, "?", obj.Attributes(nm))
End Function

Private Sub UpdPB(pt_cnt As Double)
   Static pb As Double
   If ProgressBar = -1 Then 
     pb = 0
     ProgressBar = 0
   End If  
   pb = pb + pt_cnt
   If (pb - ProgressBar) > 5  Then
     pb = IIf(pb > 100, 0, pb + Round(pt_cnt))
     ProgressBar = pb
   End If  
   
End Sub

Private Sub CompAry(ByVal part As Object)

Dim comp As Object
Dim cn As Long
Dim cmpmtch As Boolean
Dim xvlu As String
Dim cntr As Long

ReDim ary_cmps(1 To 3, 1 To 1000)  

	 cn = 1
	 
	 For Each comp In part.Components    
	   cmpmtch = False
	   xvlu = AttrVal(comp, "Value")
	   For cntr = 1 To cn
	      If xvlu = ary_cmps(1, cntr) Then
	         cmpmtch = True
	         ary_cmps(2, cntr) = ary_cmps(2, cntr) & comp & ","
	         ary_cmps(3, cntr) = CStr(CInt(ary_cmps(3, cntr)) + 1)
	         Exit For
	      End If
	   Next cntr
	   If Not cmpmtch Then  
	      ary_cmps(1, cn) = xvlu
	      ary_cmps(2, cn) = ary_cmps(2, cn) & comp & ","  
	      ary_cmps(3, cn) = "1"                          
	      cn = cn + 1 
	   End If  
	 Next comp
	 
	 ReDim Preserve ary_cmps(1 To 3, 1 To cn - 1)

End Sub

Dim CurCol As Integer	
Private Sub PrntData (txt As String)
Dim w%, n%
	w   = C_Wd(CurCol)
	  If curcol > 1 Then w = AdjWd(curcol)
	txt = Left(txt, w)
	n   = w - Len(txt)
	If C_Aln(CurCol) = 0 Then
		Print #1, txt; Space(n + 1);
	ElseIf C_Aln(curCol) = 1 Then
		Print #1, Space(n); txt; Space(1);
	Else
		Print #1, Space(n\2); txt; Space(n - n\2 + 1);
	End If
	CurCol = CurCol + 1
End Sub

Function GetCompStr(part$,cmpstr)
Dim cnt%, comp As Object
     cnt = 0
	   For Each comp In ActiveDocument.PartTypes(part).Components
	    cnt = cnt + 1
	    cmpstr = IIf (cnt < 2, cmpstr + comp, cmpstr + "," + comp)
	   Next comp 
End Function

Private Function AdjWd(clm As Integer) As Integer
Dim newclm%
   Select Case clm
     Case 2
       newclm = rfds
     Case 3
       newclm = pt
     Case 4
       newclm = pcbdl
     Case 5  
       newclm = vlu
   End Select       
 AdjWd = newclm
End Function

Private Function MaxLen(rdStr) As String
Dim lctn%, p_lctn%
lctn = 1
   Do While lctn < Len(rdStr)
     lctn = InStr(lctn,rdStr,",")
     If lctn = rfds Then
        Exit Do
     ElseIf lctn > rfds Or lctn = 0 Then
        lctn = p_lctn
        Exit Do
     End If
     p_lctn = lctn
     lctn = lctn + 1
   Loop
 MaxLen = Left(rdStr,lctn)
End Function

Private Function ML_Lister(DlgItem$, Action%, SuppValue&) As Boolean
Dim ans%

	Select Case Action%
	    Case 1 
	        DlgText "RefDesLen","12"
	        DlgValue "cbxPCBDcl", 1
	        rfds = DlgText ("RefDesLen")
	   Case 2 
	        Select Case DlgItem$
	          Case "Cancel"  
	            ProgressBar = -1
                Exit All
              Case "OK"
                If DsnChk Then
                  CRD_Bom(DlgValue("cbxPCBDcl"))
                End If  
            End Select     
            ML_Lister = True
            
	   Case 3 
                On Error Resume Next
	            ans = DlgText ("RefDesLen")
                If ans < 4 Or ans > 100 Then
                  MsgBox "Ref Des length must be between 4 and 100...",vbExclamation,"Entry error!"
                  DlgText "RefDesLen","12"
                Else
                  rfds = ans
                End If
	End Select
End Function

Private Function DsnChk As Boolean
  If ActiveDocument.PartTypes.Count = 0 Then
    MsgBox "No parts in design to report on." & vbCr _
    & "Shouldn't you load a design?", vbExclamation,"Design error!"
    DsnChk = False
  Else
    DsnChk = True
  End If  
End Function
